stages:
  - build
  - dockerhub
  - kubdeploy
  - clean_kube

before_script:
  - export IMAGE_TAG=$(git log -n1 --date=format:'%y%m%d-' --format=%cd%h)

build jar:
  stage: build
  tags:
    - kamala

  script:
    - echo $PWD
    - mvn clean package

  artifacts:
    paths:
      - target/*.jar

build and push:
  stage: dockerhub
  tags:
    - kamala

  before_script:
    - docker login -u $USER_NAME -p $PASS_WORD $REG_ISTRY

  script:
    - ls -lrt target/
    - echo $PWD
    - echo $IMAGE_TAG
    - docker build -t kamala123/maven:$IMAGE_TAG $CI_PROJECT_DIR --build-arg commit_id=$IMAGE_TAG
    - docker push kamala123/maven:$IMAGE_TAG



deploy kube:
  stage: kubdeploy
  tags:
    - kamala
  script:
    - kubectl describe namespace $CI_COMMIT_REF_NAME || kubectl create namespace $CI_COMMIT_REF_NAME
    - kubectl apply -f kub -n $CI_COMMIT_REF_NAME

cleaning:
  stage: clean_kube
  script:
    - kubectl delete namespace $CI_COMMIT_REF_NAME